/*
 * bswDispatch.c
 *
 * dispatch table for BibleSwitchLibrary shared library
 *
 * This wizard-generated code is based on code adapted from the
 * SampleLib project distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1994-1999 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
/* Our library public definitions (library API) */
#define BUILDING_BSW
#include "bsw.h"

/* Local prototypes */
Err bswInstall(UInt16 refNum, SysLibTblEntryType *entryP);
static MemPtr bswDispatchTable(void);


Err bswInstall(UInt16 refNum, SysLibTblEntryType *entryP)
{
	#pragma unused(refNum)

	/* Install pointer to our dispatch table */
	entryP->dispatchTblP = (MemPtr *) bswDispatchTable();
	
	/* Initialize globals pointer to zero (we will set up our
	 * library globals in the library "open" call). */
	entryP->globalsP = 0;

	return 0;
}

/* Palm OS uses short jumps */
#define prvJmpSize		4

/* Now, define a macro for offset list entries */
#define libDispatchEntry(index)		(kOffset+((index)*prvJmpSize))

/* Finally, define the size of the dispatch table's offset list --
 * it is equal to the size of each entry (which is presently 2
 * bytes) times the number of entries in the offset list (including
 * the @Name entry). */
#define numberOfAPIs        (23-4)
#define entrySize           (2)
#define	kOffset             (entrySize * (5 + numberOfAPIs))

static MemPtr asm bswDispatchTable(void)
{
	LEA		@Table, A0			/* table ptr */
	RTS							/* exit with it */

@Table:
	/* Offset to library name */
	DC.W		@Name
	
	/*
	 * Library function dispatch entries
	 *
	 * ***IMPORTANT***
	 * The index parameters passed to the macro libDispatchEntry
	 * must be numbered consecutively, beginning with zero.
	 *
	 * The hard-wired values need to be used for offsets because
	 * CodeWarrior's inline assembler doesn't support label subtraction.
	 */
	
    /* Standard API entry points */
	DC.W		libDispatchEntry(0)			    /* bswOpen */
	DC.W		libDispatchEntry(1)		    	/* bswClose */
	DC.W		libDispatchEntry(2)	    		/* bswSleep */
	DC.W		libDispatchEntry(3) 			/* bswWake */

    /* Custom API entry points */
    DC.W		libDispatchEntry(5 - 1)		/* bswVersion */
    DC.W		libDispatchEntry(6 - 1)		/* bswHasImplementation */
	DC.W		libDispatchEntry(7 - 1)		/* bswLaunch */
	DC.W		libDispatchEntry(8 - 1)		/* bswGetReference */
	DC.W		libDispatchEntry(9 - 1)		/* bswFindText */
	DC.W		libDispatchEntry(10 - 1)	/* bswSelectReference */
	DC.W		libDispatchEntry(11 - 1)	/* bswSelectedReference */

    DC.W        libDispatchEntry(12 - 1)     /* bswGetCount */
    DC.W        libDispatchEntry(13 - 1)     /* bswGetTranslationList */
    DC.W        libDispatchEntry(14 - 1)     /* bswFreeTranslationList */
    DC.W        libDispatchEntry(15 - 1)     /* bswGetBookID */
    DC.W        libDispatchEntry(16 - 1)     /* bswGetBooksSeqNum */
    DC.W        libDispatchEntry(17 - 1)     /* bswGetBookNames */
    DC.W        libDispatchEntry(18 - 1)     /* bswGetBooksNames */
    DC.W        libDispatchEntry(19 - 1)     /* bswFreeBookNames */
    DC.W        libDispatchEntry(20 - 1)     /* bswCompleteRef */

    DC.W        libDispatchEntry(21 - 1)     /* bswGetTotalNumBooks */
    DC.W        libDispatchEntry(22 - 1)     /* bswGetBooksNumChapters */
    DC.W        libDispatchEntry(23 - 1)     /* bswGetChaptersNumVerses */

    /* Standard API entry points */
	JMP         bswOpen
	JMP         bswClose
	JMP         bswSleep
	JMP         bswWake

    /* Custom API entry points */
    JMP			bswVersion
    JMP			bswHasImplementation
    JMP         bswLaunch
    JMP         bswGetReference
    JMP         bswFindText
    JMP         bswSelectReference
    JMP         bswSelectedReference

    JMP         bswGetCount
    JMP         bswGetTranslationList
    JMP         bswFreeTranslationList
    JMP         bswGetBookID
    JMP         bswGetBooksSeqNum
    JMP         bswGetBookNames
    JMP         bswGetBooksNames
    JMP         bswFreeBookNames
    JMP			bswCompleteRef

	JMP			bswGetTotalNumBooks
	JMP			bswGetBooksNumChapters
	JMP			bswGetChaptersNumVerses
	
@Name:
	DC.B		bswName
}
