/*
 * bswPrivate.h
 *
 * header for implementation for shared library
 *
 * This wizard-generated code is based on code adapted from the
 * SampleLib project distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1994-1999 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#ifndef BSWPRIVATE_H_
#define BSWPRIVATE_H_

/*********************************************************************
 * Private Structures
 *********************************************************************/

/* Library globals */

typedef struct bswGlobalsType
{
	/* our library reference number (for convenience and debugging) */
	UInt16 thisLibRefNum;
	
	/* library open count */
	Int16 openCount;
	
	/* number of context in existence (for debugging) */
	Int16 contextCount;
	
	/* TODO: add other library globals here */

} bswGlobalsType;

/* Client context structure for storing each client-specific data */

typedef struct {
	UInt32 implementorID;				/* CreatorID of Implementor */
	bswTranslationList*	translations;	/* Pointer to translation list */
} bswTranslationListRef;

typedef struct bswClientContextType
{
	/* signature for validating the context based on
	 * address of bswOpen routine */
	void * libSignature;

	/* TODO: add other per-client variables here */
	
	DmOpenRef dbRefVersification;
	UInt32 schemeCode;
	bswTranslationListRef tListP[32];

} bswClientContextType;

typedef bswClientContextType* bswClientContextTypePtr;


/*********************************************************************
 * Private Bible Switchboard Defines
 *********************************************************************/

#define bswPreferencesCreatorID			'BSwb'
#define bswVersificationType			'Vers'

/*********************************************************************
 * Private Macros
 *********************************************************************/

#endif /* BSWPRIVATE_H_ */
