/*
 * BiblePlusInterface.h
 *
 * header file for BiblePlus Interface
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#ifndef BIBLEPLUSINTERFACE_H_
#define BIBLEPLUSINTERFACE_H_

/*********************************************************************
 * Internal Structures
 *********************************************************************/


/*********************************************************************
 * Global variables
 *********************************************************************/


/*********************************************************************
 * Internal Constants
 *********************************************************************/

#define appFileCreator			'PBPI'
#define appName					"BiblePlus Interface"
#define appVersionNum			0x01
#define appPrefID				0x00
#define appPrefVersionNum		0x01

#define bibleCreator 'PPBL'
#define dmxVersionType 'bibl'

#define bibleAppCreator 'PBLP'
#define bibleAppPrefsFile "PBLPConfig"

typedef struct {
	UInt16 TranslationNumber;
	UInt16 CurrentBook;
	UInt16 CurrentChapter;
	UInt16 CurrentVerse;
	UInt16 Offset;
} OptionsBuffer;

#define VerseOffset 34
#define SizeOfOptionsRecord 324

extern Err Launch(bswReference* refP);
extern Err SelectedReference(bswReference* refP);
extern Err GetCount(bswCount* countP);

typedef struct {
	UInt16 ordinal;
	UInt16 cardNo;
	LocalID dbID;
	Char fullName[256];
} TranslationData;

typedef struct {
	UInt16 isVFS;
	UInt16 cardNo;
	LocalID dbID;
	DmOpenRef dbRefRAM;
	FileRef dbRefVFS;
	Char *fileName;
} DatabaseReference;

typedef struct { 
	UInt16 bookNum;
	UInt16 bookIndex;
	UInt16 totalBookRec;
	char simpleName[8];
	char complexName[32];
} BookInfoType;

typedef struct {
	char versionName[16];
	char versionInfo[128];
	char sepChar;
	UInt8 versionAttrib;
	UInt16 wordIndex;
	UInt16 totalWordRec;
	UInt16 totalBooks;
	BookInfoType bookInfo[1];
} BibleHeaderRecord;

#define infByteNotShifted	0x02

typedef struct {
	UInt16 wordLength;
	UInt16 totalWord;
	Boolean compressed;
	Boolean nothing;
} WordIndexType;

typedef struct {
	UInt16 totalIndexes;
	WordIndexType wordIndex[1];
} WordInfoType;


#define bookTextType 0xFFFF
#define chapTextType 0xFFFE
#define descTextType 0xFFFD
#define versTextType 0xFFFC

typedef UInt16 tokenReference;

extern Err GetTranslationList(bswTranslationList *tListP);
extern Err FreeTranslationList(bswTranslationList *tListP);
extern Err GetReference(bswText* textP);
extern void getWordIndexLen(WordInfoType* pLexiconIndexRecord, tokenReference token, UInt32 *decWordIndexP, UInt16 *decWordLenP, Boolean *decCompressedP);
extern UInt16 tokenStringLength(WordInfoType* pLexiconIndexRecord, UInt8** pLexiconRecord, tokenReference token);
extern void addTokenToString(BibleHeaderRecord* pHeaderRecord, WordInfoType* pLexiconIndexRecord, UInt8** pLexiconRecord, tokenReference token, UInt16* pos, Char* text, Boolean* needSpace);

#endif /* BIBLEPLUSINTERFACE_H_ */
