/*
 * FindVerse.c
 *
 * main file for FindVerse
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "bsw.h"

#include "FindVerse_Rsc.h"
#include "FindVerse.h"

/*********************************************************************
 * Entry Points
 *********************************************************************/


/*********************************************************************
 * Internal Constants
 *********************************************************************/

/* Define the minimum OS version we support */
#define ourMinVersion    sysMakeROMVersion(3,0,0,sysROMStageDevelopment,0)
#define kPalmOS20Version sysMakeROMVersion(2,0,0,sysROMStageDevelopment,0)

/*********************************************************************
 * Internal Functions
 *********************************************************************/

#define MAXREFERENCELENGTH 32

void PerformFind(FindParamsType *findParams){
	UInt16					refNum = NULL;
	UInt32					clientContext = NULL;
    char*                   header;
    Boolean                 done;
    RectangleType           r;
    UInt16                  chapterNum = 1;
    UInt16                  verseNum = 1;
	Err						err;
	bswReference			ref;
	UInt16 currentPrefs;
	UInt16 prefsSize;

	bswText text;

    // Display the heading line.
    header = "Find Verse";
    done = FindDrawHeader(findParams, header);

    if (done) return;

	err = bsw_OpenLibrary(&refNum, &clientContext);

	MemSet(&ref,sizeof(bswReference),0);
	ref.structureSize = sizeof(bswReference);
	ref.textRef = findParams->strAsTyped;
	err = bswCompleteRef(refNum, clientContext, &ref, bswTextReferenceType, bswStandardReferenceType);
    if (errNone == err)
    {
        // Add the match to the find paramter block,  if there is no
        // room to display the match the following function will
        // return true.
        done = FindSaveMatch (findParams, ref.bookNumber, ref.chapterNumber, ref.verseNumber, 0, 0, 0);
        if (!done)
        {
	        // Get the bounds of the region where we
	        // will draw the results.
	        FindGetLineBounds (findParams, &r);
			
	        // Display the match
			prefsSize=2;
			currentPrefs=0;
			PrefGetAppPreferences(appFileCreator,0,&currentPrefs,&prefsSize,true);
			if (currentPrefs) {
				MemSet(&text,sizeof(bswText),0);
				text.structureSize = sizeof(bswText);
				text.refP = &ref;
				err = bswGetReference(refNum, &text);
				if (text.text != NULL) {
					err = bswCompleteRef(refNum, clientContext, &ref, bswStandardReferenceType, bswTinyTextReferenceType);
			        WinDrawChars (ref.textRef,StrLen(ref.textRef),r.topLeft.x+1,r.topLeft.y);
			        WinDrawTruncChars (text.text,text.textLength,r.topLeft.x+50,r.topLeft.y, 100);
					MemPtrFree(text.text);
				} else {
					err = bswCompleteRef(refNum, clientContext, &ref, bswStandardReferenceType, bswTextReferenceType);
			        WinDrawChars (ref.textRef,StrLen(ref.textRef),r.topLeft.x+1,r.topLeft.y);
			    }
			} else {
				err = bswCompleteRef(refNum, clientContext, &ref, bswStandardReferenceType, bswTextReferenceType);
		        WinDrawChars (ref.textRef,StrLen(ref.textRef),r.topLeft.x+1,r.topLeft.y);
			}
	        findParams->lineNumber++;
		    if (ref.textRef) MemPtrFree(ref.textRef);
	    }
    }
    findParams->more=false;
	err = bsw_CloseLibrary(refNum, clientContext);
}

void PerformGo(GoToParamsType *goToParams){
	UInt16 refNum;
	UInt32 clientContext;
	bswReference ref;
	Err err;

	err = bsw_OpenLibrary(&refNum, &clientContext);

	MemSet(&ref,sizeof(bswReference),0);
	ref.structureSize = sizeof(bswReference);

    ref.bookNumber=goToParams->recordNum;
	ref.chapterNumber=goToParams->matchPos;
	ref.verseNumber=goToParams->matchFieldNum;
	err = bswLaunch(refNum, &ref);
	err = bsw_CloseLibrary(refNum, clientContext);
}
/*
void PerformGo(GoToParamsType *goToParams){
	UInt16 refNum;
	UInt32 clientContext;
	bswReference ref;
	bswText text;
	Err err;
	UInt16 button;

	err = bsw_OpenLibrary(&refNum, &clientContext);

	MemSet(&text,sizeof(bswText),0);
	text.structureSize = sizeof(bswText);

	MemSet(&ref,sizeof(bswReference),0);
	ref.structureSize = sizeof(bswReference);

    ref.bookNumber=goToParams->recordNum;
	ref.chapterNumber=goToParams->matchPos;
	ref.verseNumber=goToParams->matchFieldNum;
	ref.translationName="TNIV";
	text.refP = &ref;
	err = bswCompleteRef(refNum, clientContext, &ref, bswStandardReferenceType, bswTextReferenceType);
	err = bswGetReference(refNum, &text);

	if (text.text != NULL) {
		button = FrmCustomAlert(ResultsAlert, ref.textRef, text.text, " ");
		MemPtrFree(text.text);
		if (button == 1) {
			err = bswLaunch(refNum, &ref);
		} else {
			//FrmGotoForm(MainForm);
		}
	}
	if (ref.textRef != NULL) {
		MemPtrFree(ref.textRef);
	}

	err = bsw_CloseLibrary(refNum, clientContext);

}
*/

/*
 * FUNCTION: MainFormInit
 *
 * DESCRIPTION: This routine initializes the MainForm form.
 *
 * PARAMETERS:
 *
 * frm
 *     pointer to the MainForm form.
 */

static void MainFormInit(FormType *frmP)
{
	UInt16 currentPrefs;
	UInt16 prefsSize;

	prefsSize=2;
	currentPrefs=0;
	PrefGetAppPreferences(appFileCreator,0,&currentPrefs,&prefsSize,true);
	if (currentPrefs==0) {
		FrmSetControlValue(frmP, FrmGetObjectIndex(frmP, chkShowStart), 0);
	} else {
		FrmSetControlValue(frmP, FrmGetObjectIndex(frmP, chkShowStart), 1);
	}
}

/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */

static Boolean MainFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP;

	UInt16 currentPrefs;

	UInt16				cardNo;
	LocalID				dbID;
	DmSearchStateType	searchState;
	
	Err err = errNone;

	switch (eventP->eType) 
	{
		case menuCmdBarOpenEvent:
			//err = MenuCmdBarAddButton(menuCmdBarOnLeft, BarInfoBitmap, menuCmdBarResultMenuItem, HelpMenuUsage, "About");
			break;
		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			FrmDrawForm(frmP);
			MainFormInit(frmP);
			handled = true;
			break;
		case ctlSelectEvent:
			switch (eventP->data.ctlSelect.controlID){
				case aboutButton:
					FrmAlert(AboutAlert);
					handled = true;
					break;
				case megaWikiButton:
					FrmHelp(megaWikiUsage);
					handled = true;
					break;
				case chkShowStart:
					frmP = FrmGetActiveForm();
					currentPrefs = FrmGetControlValue(frmP, FrmGetObjectIndex(frmP, chkShowStart));
					PrefSetAppPreferences(appFileCreator,0,1,&currentPrefs,2,true);
					handled = true;
					break;
				case prefsButton:
					DmGetNextDatabaseByTypeCreator(true, &searchState, sysFileTPanel, prefsCreatorID, true, &cardNo, &dbID);
					if (dbID) {
						SysUIAppSwitch(cardNo, dbID, sysAppLaunchCmdPanelCalledFromApp, NULL);
					}
					handled = true;
					break;
			}
			break;
		case menuEvent:
			switch (eventP->data.menu.itemID) {
				case HelpMenuUsage:
					FrmAlert(AboutAlert);
					handled = true;
					break;
				case HelpMenuMegaWiki:
					FrmHelp(megaWikiUsage);
					handled = true;
					break;
			}
			break;
	}
	return handled;
}

/*
 * FUNCTION: AppHandleEvent
 *
 * DESCRIPTION: 
 *
 * This routine loads form resources and set the event handler for
 * the form loaded.
 *
 * PARAMETERS:
 *
 * event
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed
 *     to a higher level handler.
 */

static Boolean AppHandleEvent(EventType * eventP)
{
	UInt16 formId;
	FormType * frmP;

	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case MainForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;

		}
		return true;
	}

	return false;
}

/*
 * FUNCTION: AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.
 */

static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	do 
	{
		/* change timeout if you need periodic nilEvents */
		EvtGetEvent(&event, evtWaitForever);

		if (! SysHandleEvent(&event))
		{
			if (! MenuHandleEvent(0, &event, &error))
			{
				if (! AppHandleEvent(&event))
				{
					FrmDispatchEvent(&event);
				}
			}
		}
	} while (event.eType != appStopEvent);
}

/*
 * FUNCTION: AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * RETURNED:
 *     errNone - if nothing went wrong
 */

static Err AppStart(void)
{
	return errNone;
}

/*
 * FUNCTION: AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 */

static void AppStop(void)
{
	// Close all the open forms.
	FrmCloseAllForms();
}

/*
 * FUNCTION: RomVersionCompatible
 *
 * DESCRIPTION: 
 *
 * This routine checks that a ROM version is meet your minimum 
 * requirement.
 *
 * PARAMETERS:
 *
 * requiredVersion
 *     minimum rom version required
 *     (see sysFtrNumROMVersion in SystemMgr.h for format)
 *
 * launchFlags
 *     flags that indicate if the application UI is initialized
 *     These flags are one of the parameters to your app's PilotMain
 *
 * RETURNED:
 *     error code or zero if ROM version is compatible
 */

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	/* See if we're on in minimum required version of the ROM or later. */
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
	{
		if ((launchFlags & 
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
		{
			FrmAlert (RomIncompatibleAlert);

			/* Palm OS versions before 2.0 will continuously relaunch this
			 * app unless we switch to another safe one. */
			if (romVersion < kPalmOS20Version)
			{
				AppLaunchWithCommand(
					sysFileCDefaultApp, 
					sysAppLaunchCmdNormalLaunch, NULL);
			}
		}

		return sysErrRomIncompatible;
	}

	return errNone;
}

/*
 * FUNCTION: PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 * 
 * PARAMETERS:
 *
 * cmd
 *     word value specifying the launch code. 
 *
 * cmdPB
 *     pointer to a structure that is associated with the launch code
 *
 * launchFlags
 *     word value providing extra information about the launch.
 *
 * RETURNED:
 *     Result of launch, errNone if all went OK
 */

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error=errNone;
	UInt16 launched;

	switch (cmd)
	{
		case sysAppLaunchCmdNormalLaunch:
			error = RomVersionCompatible (ourMinVersion, launchFlags);
			if (error) return (error);

			error = AppStart();
			if (error) 
				return error;

			/* 
			 * start application by opening the main form
			 * and then entering the main event loop 
			 */
			FrmGotoForm(MainForm);
			AppEventLoop();

			AppStop();
			break;
		case sysAppLaunchCmdFind:
			PerformFind((FindParamsType*)cmdPBP);
			break;
        // This action code might be sent to the app when
        // it's already running
        // if the use hits the "Go To" button in the
        // Find Results dialog.
        case sysAppLaunchCmdGoTo:
        	launched = launchFlags & sysAppLaunchFlagNewGlobals;
            if (launched)
            {
                error = AppStart();
                if (error) return (error);
            }
			PerformGo((GoToParamsType*)cmdPBP);
            if (launched)
            {
				AppEventLoop();
				AppStop();
			}
			break;
	}

	return error;
}
