/* ShowVerseOBC.h */
#define maxFindStrLen 16
typedef struct {
        // These fields are used by the applications.
        UInt16               dbAccesMode;          // read mode and maybe show secret
        UInt16                       recordNum;                   // index of last record that contained a match
        Boolean                      more;                              // true of more matches to display
        Char                        strAsTyped [maxFindStrLen+1];  // search string as entered
        Char                        strToFind [maxFindStrLen+1];   // search string is lower case
        UInt8                reserved1;

        // The lineNumber field can be modified by the app. The continuation field can
        // be tested by the app. All other fields are private to the Find routine and
        // should NOT be accessed by applications.
       UInt16               noAccessAllowed1;      // # of matches
        UInt16               lineNumber;                  // next line in the results tabel
        Boolean                      continuation;         // true if contining search of same app
        Boolean                      noAccessAllowed2;      // padding
} FindParamsType;
typedef FindParamsType *FindParamsPtr;
typedef GoToParamsType *GoToParamsPtr;
void Find (GoToParamsPtr goToP) SYS_TRAP(sysTrapFind);
Boolean FindSaveMatch (FindParamsPtr findParams, UInt16 recordNum, UInt16 pos, UInt16 fieldNum, UInt32 appCustom, UInt16 cardNo, LocalID dbID) SYS_TRAP(sysTrapFindSaveMatch);
void FindGetLineBounds (const FindParamsType *findParams, RectanglePtr r) SYS_TRAP(sysTrapFindGetLineBounds);
Boolean FindDrawHeader (FindParamsPtr findParams, Char *title) SYS_TRAP(sysTrapFindDrawHeader);
void WinDrawTruncChars(const Char *chars, Int16 len, Coord x, Coord y, Coord maxWidth) SYS_TRAP(sysTrapWinDrawTruncChars);
extern void FrmSetTitle (FormType *formP, Char *newTitle) SYS_TRAP(sysTrapFrmSetTitle);
extern WinHandle FrmGetWindowHandle (const FormType *formP) SYS_TRAP(sysTrapFrmGetWindowHandle);
#define commandKeyMask     0x0008
#define vchrCalc                                          0x010B
#define vchrHardKeyMin                      0x0200
#define vchrHardKeyMax                      0x02FF               // 256 hard keys
#define calcChr                                           vchrCalc                                                 // 0x010B
#define hardKeyMin                                 vchrHardKeyMin                             // 0x0200
#define hardKeyMax                                 vchrHardKeyMax                             // 0x02FF
#define TxtCharIsHardKey(m, c) ((((m) & commandKeyMask) != 0) && ((((c) >= hardKeyMin) && ((c) <= hardKeyMax)) || ((c) == calcChr)))
extern Boolean RctPtInRectangle (Coord x, Coord y, const RectangleType *rP) SYS_TRAP(sysTrapRctPtInRectangle);
extern Boolean FrmPointInTitle (const FormType *formP, Coord x, Coord y) SYS_TRAP(sysTrapFrmPointInTitle);
void WinGetDisplayExtent (Coord *extentX, Coord *extentY) SYS_TRAP(sysTrapWinGetDisplayExtent);
WinHandle WinGetDisplayWindow (void) SYS_TRAP(sysTrapWinGetDisplayWindow);
Err            SysCurAppDatabase(UInt16 *cardNoP, LocalID *dbIDP) SYS_TRAP(sysTrapSysCurAppDatabase);
typedef struct SysNotifyParamType
        {
        UInt32        notifyType;           // What type of event occurred?
        UInt32        broadcaster;   // normally creator code of broadcasting app
        void *        notifyDetailsP;        // ptr to notification-specific data, if any
        void *        userDataP;            // user specified ptr passed back with notification
        Boolean               handled;              // true if event is handled yet
        UInt8         reserved2;
        } SysNotifyParamType;
typedef Err (*SysNotifyProcPtr)(SysNotifyParamType *notifyParamsP);
#define sysNotifyNormalPriority        0      // clients should use this priority
extern Err SysNotifyRegister(UInt16 cardNo, LocalID dbID, UInt32 notifyType, SysNotifyProcPtr callbackP, Int8 priority, void *userDataP) SYS_TRAP(sysTrapSysNotifyRegister);
extern Err SysNotifyUnregister(UInt16 cardNo, LocalID dbID, UInt32 notifyType, Int8 priority) SYS_TRAP(sysTrapSysNotifyUnregister);
#define sysNotifyMenuCmdBarOpenEvent    'cbar'
typedef enum {
        menuCmdBarResultNone,                // send nothing (this'd be quite unusual but is allowed)
        menuCmdBarResultChar,                // char to send (with commandKeyMask bit set)
        menuCmdBarResultMenuItem,             // id of the menu item
        menuCmdBarResultNotify               // Nofication Manager notification type
} MenuCmdBarResultType;
extern Err MenuCmdBarAddButton(UInt8 where, UInt16 bitmapId, MenuCmdBarResultType resultType, UInt32 result, Char *nameP) SYS_TRAP(sysTrapMenuCmdBarAddButton);
#define menuCmdBarOnLeft  0xff
#define sysFileTPanel                                     'panl' // File type for preference panels
Err            SysUIAppSwitch(UInt16 cardNo, LocalID dbID, UInt16 cmd, MemPtr cmdPBP) SYS_TRAP(sysTrapSysUIAppSwitch);
#define sysAppLaunchCmdPanelCalledFromApp      13
#define sysAppLaunchCmdNotify                                      51
#define sysMakeROMVersion(major, minor, fix, stage)                 \
               (                                                                                                                                                  \
               (((UInt32)((UInt8)(major) & 0x0FF)) << 24) |                                             \
               (((UInt32)((UInt8)(minor) & 0x00F)) << 20) |                                             \
               (((UInt32)((UInt8)(fix)   & 0x00F)) << 16) |                                             \
               (((UInt32)((UInt8)(stage) & 0x00F)) << 12)                                              \
                )
void FrmGetFormBounds(FormType *formP,RectangleType *rP) SYS_TRAP(sysTrapFrmGetFormBounds);
void WinSetWindowBounds(WinHandle wH,RectangleType *rP) SYS_TRAP(sysTrapWinSetWindowBounds);
#define noFocus 0xffff
extern FormObjectKind FrmGetObjectType (const FormType *formP, UInt16 objIndex) SYS_TRAP(sysTrapFrmGetObjectType);
extern void FldGetScrollValues (const FieldType *fldP, UInt16 *scrollPosP, UInt16 *textHeightP, UInt16 *fieldHeightP) SYS_TRAP(sysTrapFldGetScrollValues);
extern void FldScrollField (FieldType *fldP, UInt16 linesToScroll, WinDirectionType direction) SYS_TRAP(sysTrapFldScrollField);
extern Boolean FldInsert (FieldType *fldP, const Char *insertChars, UInt16 insertLen) SYS_TRAP(sysTrapFldInsert);
extern void FldSetInsPtPosition(FieldType *fldP, UInt16 pos) SYS_TRAP(sysTrapFldSetInsPtPosition);
#define dmModeLeaveOpen                      0x0004        // leave open when app quits

#define sysAppLaunchCmdSystemReset                   5